SystemOrganization addCategory: #Bundleview!

Object subclass: #FirstClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/18/2012 17:03'!
countBackwards: x
	"counts a given number backwards till zero"
	| temp |
	temp := x.
	[temp > 0] whileTrue: [
		temp := temp - 1.
		Transcript show: temp
	].! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/19/2012 14:00'!
drawACircleAt: aPoint
	"drawing a circle."
	| morph size |
	size := 20.
	morph := CircleMorph new.
	morph bounds: (Rectangle origin: (aPoint - ((size@size)/2)) extent: (size@size)).
	morph color: Color random.
	"morph setVertices: (OrderedCollection with: 100@100 with: 200@100 with: 100@200).
	morph color: (Color h: 40 s: 0.7 v: 0.6 alpha: 0.5).
	morph borderWidth: 5.
	morph borderColor:  (Color h: 170 s: 0.7 v: 0.6 alpha: 0.6).
	morph makeOpen."
	morph openInWorld.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/19/2012 14:24'!
drawALineFrom: aPoint To: anotherPoint
	"drawing a circle."
	| morph |
	morph := LineMorph from: aPoint to: anotherPoint color: Color black width: 2.
	morph openInWorld.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/19/2012 13:30'!
drawAPolyLine
	"showcase for drawing a polygon line."
	| morph |
	morph := PolygonMorph new.
	morph setVertices: (OrderedCollection with: 100@100 with: 200@100 with: 100@200).
	morph color: (Color h: 40 s: 0.7 v: 0.6 alpha: 0.5).
	morph borderWidth: 5.
	morph borderColor:  (Color h: 170 s: 0.7 v: 0.6 alpha: 0.6).
	morph makeOpen.
	morph openInWorld.! !

!FirstClass methodsFor: 'as yet unclassified' stamp: 'SL 10/17/2012 15:57'!
firstMethod
	^self.! !

Object subclass: #Node
	instanceVariableNames: 'children parent relations weight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!Node commentStamp: 'CR 10/19/2012 10:33' prior: 0!
A Node is a part of a graph data structure. It knows its parent and its children as well of all relations that connect the node to an other node.

Instance Variables
	children:		<Object>
	parent:		<Object>
	relations:		<Object>

children
	- xxxxx

parent
	- xxxxx

relations
	- xxxxx
!

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:11'!
addChild: aChild
	children add: aChild.
	aChild parent: self.! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:29'!
addRelation: aRelation
	relations add: aRelation.! !

!Node methodsFor: 'as yet unclassified' stamp: 'CR 10/19/2012 15:50'!
calculateWeight
	"calculate the weight of this node depending on the weight of the children"

	| calculatedWeight |
	calculatedWeight := 1.
	self children
		ifEmpty: [calculatedWeight := self weight]
		ifNotEmpty: [self children do: [ :child | calculatedWeight := calculatedWeight + child calculateWeight]].
	self weight: calculatedWeight.
	^calculatedWeight! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:24'!
children
	^children! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:37'!
depth
	self isRoot
		ifTrue: [^1]
		ifFalse: [^1 + parent depth].! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:59'!
getMaxDepth
	"get depth of the whole (sub-)tree."
	| maxDepthOfChildren |
	maxDepthOfChildren := children inject: 0 into: [:prev :child | (prev > child getMaxDepth)
		ifTrue: [prev]
		ifFalse: [child getMaxDepth]].
	^ maxDepthOfChildren + 1.
! !

!Node methodsFor: 'initializing' stamp: 'CR 10/19/2012 13:30'!
initialize
	super initialize.
	weight := 1.
	children := OrderedCollection new.
	relations := OrderedCollection new.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:26'!
isLeaf
	^ children isEmpty.! !

!Node methodsFor: 'accessing' stamp: 'SL 10/19/2012 15:07'!
isRoot
	^ parent isNil.! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:13'!
parent
	"Answer the value of parent"

	^ parent! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:14'!
parent: anObject
	"Set the value of parent"

	parent := anObject! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:30'!
relations
	^relations! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 14:23'!
weight
	^weight! !

!Node methodsFor: 'accessing' stamp: 'CR 10/19/2012 14:23'!
weight: aNumber
	weight := aNumber.! !

Object subclass: #Relation
	instanceVariableNames: 'source destination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!Relation commentStamp: 'CR 10/19/2012 10:34' prior: 0!
A Relation describes an usally non hierarchical connection between two nodes.

Instance Variables
	destination:		<Object>
	source:		<Object>

destination
	- xxxxx

source
	- xxxxx
!

!Relation methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:28'!
destination
	"Answer the value of destination"

	^ destination! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:28'!
destination: anObject
	"Set the value of destination"

	destination := anObject! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:28'!
source
	"Answer the value of source"

	^ source! !

!Relation methodsFor: 'accessing' stamp: 'CR 10/19/2012 10:28'!
source: anObject
	"Set the value of source"

	source := anObject! !

Object subclass: #RootedTreeRenderer
	instanceVariableNames: 'maxWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!RootedTreeRenderer methodsFor: 'accessing' stamp: 'CR 10/19/2012 15:55'!
maxWidth
	"Answer the value of maxWidth"

	^ maxWidth! !

!RootedTreeRenderer methodsFor: 'accessing' stamp: 'CR 10/19/2012 15:55'!
maxWidth: anObject
	"Set the value of maxWidth"

	maxWidth := anObject! !

!RootedTreeRenderer methodsFor: 'as yet unclassified' stamp: 'CR 10/19/2012 15:55'!
renderRootedTreeFor2: aRootNode at: aPoint
	"render a rooted tree with the given Node as root node"

	| nextChildren positionOfChildren |
	"draw node at aPoint"
	Transcript show: 'render node'.
	"calculate Position for every child"
	"draw edge to every child"
	"call renderRootedTreeFor for every child"
	nextChildren := aRootNode children.! !

!RootedTreeRenderer methodsFor: 'as yet unclassified' stamp: 'CR 10/19/2012 15:59'!
renderRootedTreeFor: aRootNode at: aPoint
	"render a rooted tree with the given Node as root node"

	"TODO: test if calculateWeight is nesassary"
	aRootNode calculateWeight.
	self maxWidth: aRootNode weight.! !

Object subclass: #TreeBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bundleview'!

!TreeBuilder class methodsFor: 'as yet unclassified' stamp: 'SL 10/19/2012 14:59'!
buildTestTree
	"creates a simple Treestructure"
	|			 				node1 
				node11 			       			node12 
	node111    node112    node113 		node121 		node122 
										      			node1221	node1222 |
	node1 := Node new.
	node11 := Node new.
	node111 := Node new.
	node112 := Node new.
	node113 := Node new.
	node12 := Node new.
	node121 := Node new.
	node122 := Node new.
	node1221 := Node new.
	node1222 := Node new.
	
	node1 addChild: node11.
	node11 addChild: node111.
	node11 addChild: node112.
	node11 addChild: node113.
	node1 addChild: node12.
	node12 addChild: node121.
	node12 addChild: node122.
	node122 addChild: node1221.
	node122 addChild: node1222.
	^node1.! !
